/* CFX_XSLT
 * By: Pete Freitag
 * Company: CFDEV.COM
 * Copyright 2002
 */

// Imported TraX classes
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.Transformer;
import javax.xml.transform.stream.StreamSource;
import javax.xml.transform.stream.StreamResult;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerConfigurationException;

import java.io.*;

import com.allaire.cfx.*;

public class CFX_XSLT
    implements CustomTag
{
    public void processRequest(Request request, Response response)
        throws TransformerException, TransformerConfigurationException, 
           FileNotFoundException, IOException, Exception
    {
        String xml = "";
        String xsl = "";
        String output = "CFX_XSLT.result";
        String xsltype = "string";
        String xmltype = "string";
        StreamSource xslSource = null;
        StreamSource xmlSource = null;
                
        if (request.attributeExists("OUTPUT"))
        {
            output = request.getAttribute("OUTPUT");
        }
        
        if (request.attributeExists("XSLFILE")) 
        {
            xslSource = new StreamSource ( 
                new File( request.getAttribute("XSLFILE") ) );
        }
        else if (request.attributeExists("XSL"))
        {
            xslSource = new StreamSource ( 
                new StringReader( request.getAttribute("XSL") ) );
        }
        else {
            throw new Exception("No XSL Input specified. Use XSL or XSLFILE attributes");
           
        }
        
        if (request.attributeExists("XMLFILE")) 
        {
            xmlSource = new StreamSource ( 
                new File( request.getAttribute("XMLFILE") ) );
        }
        else if (request.attributeExists("XML"))
        {
            xmlSource = new StreamSource ( 
                new StringReader( request.getAttribute("XML") ) );
        }
        else {
            throw new Exception("No XML Input specified. Use XML or XMLFILE attributes");
            
        }
        
        TransformerFactory tFactory = TransformerFactory.newInstance();
        Transformer transformer = tFactory.newTransformer(xslSource);
        
        StringWriter writer = new StringWriter();
        StreamResult result = new StreamResult(writer);
        
        //do the actual transformation
	transformer.transform(xmlSource, result);
        
	response.setVariable(output, writer.toString());
    }
    
}